#include <string.h>
#include <time.h>
#include <stdlib.h>

#ifndef _CDI_H
#  include "cdi.h"
#endif

static char *ghistory = NULL;
static size_t ghistorysize = 0;

static char strtime[20];

void init_strtime()
{
  time_t tp;
  struct tm *ltime;

  tp = time(NULL);

  if ( tp != -1 )
    {
      ltime = localtime(&tp);
      (void) strftime(strtime, 20, "%d %b %Y : ", ltime);
    }
}

char *get_strtimeptr()
{
  if ( strlen(strtime) == 0 )
    init_strtime();

  return (strtime);
}

void gmInqHistory(int fileID)
{
  if ( ghistory )
    {
      free(ghistory);
      ghistorysize = 0;
      ghistory = NULL;
    }

  ghistorysize = streamInqHistorySize(fileID);
  if ( ghistorysize > 0 )
    {
      size_t len;
      ghistory = (char *) malloc(ghistorysize+1);
      streamInqHistoryString(fileID, ghistory);
      len = strlen(ghistory);
      if ( len < ghistorysize )
	{
	  /* printf("%d %d\n", len, ghistorysize); */
	  ghistorysize = len;
	}
      ghistory[ghistorysize] = '\n';
      ghistorysize += 1;
    }
}

void gmDefHistory(int fileID, char *histstring)
{
  char *history = NULL;
  size_t historysize = 0;
  char *strtimeptr;
  int strtimelen;

  strtimeptr = get_strtimeptr();
  strtimelen = strlen(strtimeptr);
  
  historysize = ghistorysize+strtimelen+strlen(histstring)+1;
  history = (char *) malloc(historysize);

  strncpy(history, ghistory, ghistorysize);
  strncpy(history+ghistorysize, strtimeptr, strtimelen);
  strcpy(history+ghistorysize+strtimelen, histstring);
  streamDefHistory(fileID, strlen(history), history);
  
  free(history);
}
